PostgreSQL API Reference
Validated on 26 Jul 2019 • Last edited on 23 Mar 2026
DigitalOcean's managed database service simplifies the creation and management of highly available database clusters. Currently, it offers support for PostgreSQL, Caching, Valkey, MySQL, MongoDB, and OpenSearch.
By sending requests to the /v2/databases endpoint, you can list, create, or delete
database clusters as well as scale the size of a cluster, add or remove read-only replicas,
and manage other configuration details.
Database clusters may be deployed in a multi-node, high-availability configuration. If your machine type is above the basic nodes, your node plan is above the smallest option, or you are running MongoDB, you may additionally include up to two standby nodes in your cluster.
The size of individual nodes in a database cluster is represented by a human-readable slug, which is used in some of the following requests. Each slug denotes the node's identifier, CPU count, and amount of RAM, in that order.
For a list of currently available database slugs and options, use the /v2/databases/options endpoint or use the
doctl databases options command.
https://api.digitalocean.com
Endpoints
GET List All Database Clusters
/v2/databases
Authorizations:
bearer_auth
(1 scope)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To list all of the database clusters available on your account, send a GET request to /v2/databases. To limit the results to database clusters with a specific tag, include the tag_name query parameter set to the name of the tag. For example, /v2/databases?tag_name=$TAG_NAME.
The result will be a JSON object with a databases key. This will be set to an array of database objects, each of which will contain the standard database attributes.
The embedded connection and private_connection objects will contain the information needed to access the database cluster. For multi-node clusters, the standby_connection and standby_private_connection objects will contain the information needed to connect to the cluster's standby node(s).
The embedded maintenance_window object will contain information about any scheduled maintenance for the database cluster.
Query Parameters
tag_name
optional
productionLimits the results to database clusters with a specific tag.
Requires tag:read scope.
Request: /v2/databases
curl -X GET \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
"https://api.digitalocean.com/v2/databases"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
opt := &godo.ListOptions{
Page: 1,
PerPage: 200,
}
clusters, _, err := client.Databases.List(ctx, opt)
}import os
from pydo import Client
client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))
get_resp = client.databases.list_clusters(tag_name="production")Responses
200
A JSON object with a key of databases.
databases.ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
databases
optional
Show child properties
connection
optional
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the database cluster was created.
db_names
optional read-only Nullable
["doadmin"]An array of strings containing the names of databases created in the database cluster.
do_settings
optional
engine
required
mysqlA slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, and "valkey" for Valkey.
id
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID that can be used to identify and reference a database cluster.
maintenance_window
optional
metrics_endpoints
optional read-only
Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).
Show child properties
host
optional read-only
backend-do-user-19081923-0.db.ondigitalocean.comA FQDN pointing to the database cluster's node(s).
port
optional read-only
9273The port on which a service is listening.
name
required
backendA unique, human-readable name referring to a database cluster.
num_nodes
required
2The number of nodes in the database cluster.
private_connection
optional
private_network_uuid
optional
d455e75d-4858-4eec-8c95-da2f0a5f93a7A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.
Requires vpc:read scope.
project_id
optional
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.
Requires project:read scope.
region
required
nyc3The slug identifier for the region where the database cluster is located.
rules
optional
Show child properties
cluster_uuid
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID for the database cluster to which the rule is applied.
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the firewall rule was created.
description
optional
an IP address for local developmentA human-readable description of the rule.
type
required
dropletThe type of resource that the firewall rule allows to access the database cluster.
uuid
optional
79f26d28-ea8a-41f2-8ad8-8cfcdd020095A unique ID for the firewall rule itself.
value
required
ff2a6c52-5a44-4b63-b99c-0e98e7a63d61The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.
schema_registry_connection
optional
The connection details for Schema Registry.
semantic_version
optional read-only
8.0.28A string representing the semantic version of the database engine in use for the cluster.
size
required
db-s-2vcpu-4gbThe slug identifier representing the size of the nodes in the database cluster.
standby_connection
optional
standby_private_connection
optional
status
optional read-only
creatingA string representing the current status of the database cluster.
storage_size_mib
optional
61440Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.
tags
optional Nullable
["production"]An array of tags that have been applied to the database cluster.
Requires tag:read scope.
ui_connection
optional
The connection details for OpenSearch dashboard.
users
optional read-only Nullable
Show child properties
access_cert
optional read-only
Access certificate for TLS client authentication. (Kafka only)
access_key
optional read-only
Access key for TLS client authentication. (Kafka only)
mysql_settings
optional
Show child properties
auth_plugin
required
mysql_native_passwordA string specifying the authentication method to be used for connections
to the MySQL user account. The valid values are mysql_native_password
or caching_sha2_password. If excluded when creating a new user, the
default for the version of MySQL in use will be used. As of MySQL 8.0, the
default is caching_sha2_password.
name
required
app-01The name of a database user.
password
optional read-only
jge5lfxtzhx42iffA randomly generated password for the database user.
Requires database:view_credentials scope.
role
optional read-only
normalA string representing the database user's role. The value will be either "primary" or "normal".
settings
optional
Show child properties
acl
optional
ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.
mongo_user_settings
optional
MongoDB-specific settings for the user. This option is not currently supported for other database engines.
opensearch_acl
optional
ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.
pg_allow_replication
optional
trueFor Postgres clusters, set to true for a user with replication rights.
This option is not currently supported for other database engines.
version
optional
8A string representing the version of the database engine in use for the cluster.
version_end_of_availability
optional read-only
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
version_end_of_life
optional read-only
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
401
Authentication failed due to invalid credentials.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
404
The resource was not found.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
429
The API rate limit has been exceeded.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
500
There was a server error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
default
There was an unexpected error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
Response
{
"databases": [
{
"connection": {
"database": "",
"host": "backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"created_at": "2019-01-11T18:37:36Z",
"db_names": [
"defaultdb"
],
"engine": "pg",
"id": "9cc10173-e9ea-4176-9dbc-a4cee4c4ff30",
"maintenance_window": {
"day": "saturday",
"description": [
"Update TimescaleDB to version 1.2.1",
"Upgrade to PostgreSQL 11.2 and 10.7 bugfix releases"
],
"hour": "08:45:12",
"pending": true
},
"name": "backend",
"num_nodes": 1,
"private_connection": {
"database": "",
"host": "private-backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@private-backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"private_network_uuid": "d455e75d-4858-4eec-8c95-da2f0a5f93a7",
"region": "nyc3",
"size": "db-s-2vcpu-4gb",
"status": "online",
"storage_size_mib": 61440,
"tags": [
"production"
],
"users": [
{
"name": "doadmin",
"password": "wv78n3zpz42xezdk",
"role": "primary"
}
],
"version": "10",
"version_end_of_availability": "2023-05-09T00:00:00Z",
"version_end_of_life": "2023-11-09T00:00:00Z"
}
]
}{
"id": "unauthorized",
"message": "Unable to authenticate you."
}{
"id": "not_found",
"message": "The resource you requested could not be found."
}{
"id": "too_many_requests",
"message": "API rate limit exceeded."
}{
"id": "server_error",
"message": "Unexpected server-side error"
}{
"id": "example_error",
"message": "some error message"
}POST Create a New Database Cluster
/v2/databases
Authorizations:
bearer_auth
(1 scope)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To create a database cluster, send a POST request to /v2/databases. To see a list of options for each engine, such as available regions, size slugs, and versions, send a GET request to the /v2/databases/options endpoint. The available sizes for the storage_size_mib field depends on the cluster's size. To see a list of available sizes, see Managed Database Pricing.
The create response returns a JSON object with a key called database. The value of this is an object that contains the standard attributes associated with a database cluster. The initial value of the database cluster's status attribute is creating. When the cluster is ready to receive traffic, this changes to online.
The embedded connection and private_connection objects contains the information needed to access the database cluster. For multi-node clusters, the standby_connection and standby_private_connection objects contain the information needed to connect to the cluster's standby node(s).
DigitalOcean managed PostgreSQL and MySQL database clusters take automated daily backups. To create a new database cluster based on a backup of an existing cluster, send a POST request to /v2/databases. In addition to the standard database cluster attributes, the JSON body must include a key named backup_restore with the name of the original database cluster and the timestamp of the backup to be restored. Creating a database from a backup is the same as forking a database in the control panel.
Note: Caching cluster creates are no longer supported as of 2025-04-30T00:00:00Z. Backups are also not supported for Caching or Valkey clusters.
Request Body: application/json
autoscale
optional
Autoscaling configuration for the database cluster. Currently only supports storage autoscaling. If null, autoscaling is not configured for the cluster.
connection
optional
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the database cluster was created.
db_names
optional read-only Nullable
["doadmin"]An array of strings containing the names of databases created in the database cluster.
do_settings
optional
engine
required
mysqlA slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, and "valkey" for Valkey.
id
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID that can be used to identify and reference a database cluster.
maintenance_window
optional
metrics_endpoints
optional read-only
Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).
Show child properties
host
optional read-only
backend-do-user-19081923-0.db.ondigitalocean.comA FQDN pointing to the database cluster's node(s).
port
optional read-only
9273The port on which a service is listening.
name
required
backendA unique, human-readable name referring to a database cluster.
num_nodes
required
2The number of nodes in the database cluster.
private_connection
optional
private_network_uuid
optional
d455e75d-4858-4eec-8c95-da2f0a5f93a7A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.
Requires vpc:read scope.
project_id
optional
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.
Requires project:update scope.
region
required
nyc3The slug identifier for the region where the database cluster is located.
rules
optional
Show child properties
cluster_uuid
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID for the database cluster to which the rule is applied.
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the firewall rule was created.
description
optional
an IP address for local developmentA human-readable description of the rule.
type
required
dropletThe type of resource that the firewall rule allows to access the database cluster.
uuid
optional
79f26d28-ea8a-41f2-8ad8-8cfcdd020095A unique ID for the firewall rule itself.
value
required
ff2a6c52-5a44-4b63-b99c-0e98e7a63d61The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.
schema_registry_connection
optional
The connection details for Schema Registry.
semantic_version
optional read-only
8.0.28A string representing the semantic version of the database engine in use for the cluster.
size
required
db-s-2vcpu-4gbThe slug identifier representing the size of the nodes in the database cluster.
standby_connection
optional
standby_private_connection
optional
status
optional read-only
creatingA string representing the current status of the database cluster.
storage_size_mib
optional
61440Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.
tags
optional Nullable
["production"]An array of tags (as strings) to apply to the database cluster.
Requires tag:create scope.
ui_connection
optional
The connection details for OpenSearch dashboard.
users
optional read-only Nullable
Show child properties
access_cert
optional read-only
Access certificate for TLS client authentication. (Kafka only)
access_key
optional read-only
Access key for TLS client authentication. (Kafka only)
mysql_settings
optional
Show child properties
auth_plugin
required
mysql_native_passwordA string specifying the authentication method to be used for connections
to the MySQL user account. The valid values are mysql_native_password
or caching_sha2_password. If excluded when creating a new user, the
default for the version of MySQL in use will be used. As of MySQL 8.0, the
default is caching_sha2_password.
name
required
app-01The name of a database user.
password
optional read-only
jge5lfxtzhx42iffA randomly generated password for the database user.
Requires database:view_credentials scope.
role
optional read-only
normalA string representing the database user's role. The value will be either "primary" or "normal".
settings
optional
Show child properties
acl
optional
ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.
Show child properties
id
optional
aaaAn identifier for the ACL. Will be computed after the ACL is created/updated.
permission
required
consumePermission set applied to the ACL. 'consume' allows for messages to be consumed from the topic. 'produce' allows for messages to be published to the topic. 'produceconsume' allows for both 'consume' and 'produce' permission. 'admin' allows for 'produceconsume' as well as any operations to administer the topic (delete, update).
topic
required
topic-abc.*A regex for matching the topic(s) that this ACL should apply to.
mongo_user_settings
optional
MongoDB-specific settings for the user. This option is not currently supported for other database engines.
Show child properties
databases
optional
["my-db","my-db-2"]A list of databases to which the user should have access. When the database is set to admin, the user will have access to all databases based on the user's role i.e. a user with the role readOnly assigned to the admin database will have read access to all databases.
opensearch_acl
optional
ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.
Show child properties
index
optional
index-abc.*A regex for matching the indexes that this ACL should apply to.
permission
optional
readPermission set applied to the ACL. 'read' allows user to read from the index. 'write' allows for user to write to the index. 'readwrite' allows for both 'read' and 'write' permission. 'deny'(default) restricts user from performing any operation over an index. 'admin' allows for 'readwrite' as well as any operations to administer the index.
pg_allow_replication
optional
trueFor Postgres clusters, set to true for a user with replication rights.
This option is not currently supported for other database engines.
version
optional
8A string representing the version of the database engine in use for the cluster.
version_end_of_availability
optional read-only
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
version_end_of_life
optional read-only
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
backup_restore
optional
Show child properties
backup_created_at
optional
2019-01-31T19:25:22ZThe timestamp of an existing database cluster backup in ISO8601 combined date and time format. The most recent backup will be used if excluded.
database_name
required
backendThe name of an existing database cluster from which the backup will be restored.
Request: /v2/databases
{
"engine": "pg",
"name": "backend",
"num_nodes": 2,
"region": "nyc3",
"size": "db-s-2vcpu-4gb",
"storage_size_mib": 61440,
"tags": [
"production"
],
"version": "14"
}curl -X POST \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
-d '{"name": "backend", "engine": "pg", "version": "14", "region": "nyc3", "size": "db-s-2vcpu-4gb", "num_nodes": 2, "storage_size_mib": 61440, "tags": ["production"], "do_settings": {"service_cnames": ["db.example.com", "database.myapp.io"]}}' \
"https://api.digitalocean.com/v2/databases"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
createRequest := &godo.DatabaseCreateRequest{
Name: "backend",
EngineSlug: "pg",
Version: "14",
Region: "nyc3",
SizeSlug: "db-s-2vcpu-4gb",
NumNodes: 2,
StorageSizeMiB : 61440,
DOSettings: &godo.DOSettings{
ServiceCnames: []string{"db.example.com", "database.myapp.io"},
},
}
cluster, _, err := client.Databases.Create(ctx, createRequest)
}import os
from pydo import Client
client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))
create_req = {
"name": "backend",
"engine": "pg",
"version": "14",
"region": "nyc3",
"size": "db-s-2vcpu-4gb",
"num_nodes": 2,
"storage_size_mib": 61440,
"tags": [
"production"
],
"do_settings": {
"service_cnames": [
"db.example.com",
"database.myapp.io"
]
}
}
create_resp = client.databases.create_cluster(body=create_req)Responses
201
A JSON object with a key of database.
database.ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
database
required
Show child properties
connection
optional
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the database cluster was created.
db_names
optional read-only Nullable
["doadmin"]An array of strings containing the names of databases created in the database cluster.
do_settings
optional
engine
required
mysqlA slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, and "valkey" for Valkey.
id
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID that can be used to identify and reference a database cluster.
maintenance_window
optional
metrics_endpoints
optional read-only
Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).
Show child properties
host
optional read-only
backend-do-user-19081923-0.db.ondigitalocean.comA FQDN pointing to the database cluster's node(s).
port
optional read-only
9273The port on which a service is listening.
name
required
backendA unique, human-readable name referring to a database cluster.
num_nodes
required
2The number of nodes in the database cluster.
private_connection
optional
private_network_uuid
optional
d455e75d-4858-4eec-8c95-da2f0a5f93a7A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.
Requires vpc:read scope.
project_id
optional
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.
Requires project:read scope.
region
required
nyc3The slug identifier for the region where the database cluster is located.
rules
optional
Show child properties
cluster_uuid
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID for the database cluster to which the rule is applied.
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the firewall rule was created.
description
optional
an IP address for local developmentA human-readable description of the rule.
type
required
dropletThe type of resource that the firewall rule allows to access the database cluster.
uuid
optional
79f26d28-ea8a-41f2-8ad8-8cfcdd020095A unique ID for the firewall rule itself.
value
required
ff2a6c52-5a44-4b63-b99c-0e98e7a63d61The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.
schema_registry_connection
optional
The connection details for Schema Registry.
semantic_version
optional read-only
8.0.28A string representing the semantic version of the database engine in use for the cluster.
size
required
db-s-2vcpu-4gbThe slug identifier representing the size of the nodes in the database cluster.
standby_connection
optional
standby_private_connection
optional
status
optional read-only
creatingA string representing the current status of the database cluster.
storage_size_mib
optional
61440Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.
tags
optional Nullable
["production"]An array of tags that have been applied to the database cluster.
Requires tag:read scope.
ui_connection
optional
The connection details for OpenSearch dashboard.
users
optional read-only Nullable
Show child properties
access_cert
optional read-only
Access certificate for TLS client authentication. (Kafka only)
access_key
optional read-only
Access key for TLS client authentication. (Kafka only)
mysql_settings
optional
Show child properties
auth_plugin
required
mysql_native_passwordA string specifying the authentication method to be used for connections
to the MySQL user account. The valid values are mysql_native_password
or caching_sha2_password. If excluded when creating a new user, the
default for the version of MySQL in use will be used. As of MySQL 8.0, the
default is caching_sha2_password.
name
required
app-01The name of a database user.
password
optional read-only
jge5lfxtzhx42iffA randomly generated password for the database user.
Requires database:view_credentials scope.
role
optional read-only
normalA string representing the database user's role. The value will be either "primary" or "normal".
settings
optional
Show child properties
acl
optional
ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.
mongo_user_settings
optional
MongoDB-specific settings for the user. This option is not currently supported for other database engines.
opensearch_acl
optional
ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.
pg_allow_replication
optional
trueFor Postgres clusters, set to true for a user with replication rights.
This option is not currently supported for other database engines.
version
optional
8A string representing the version of the database engine in use for the cluster.
version_end_of_availability
optional read-only
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
version_end_of_life
optional read-only
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
401
Authentication failed due to invalid credentials.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
404
The resource was not found.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
429
The API rate limit has been exceeded.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
500
There was a server error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
default
There was an unexpected error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
Response
{
"database": {
"connection": {
"database": "",
"host": "backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"created_at": "2019-01-11T18:37:36Z",
"db_names": [
"defaultdb"
],
"do_settings": {
"service_cnames": [
"db.example.com",
"database.myapp.io"
]
},
"engine": "pg",
"id": "9cc10173-e9ea-4176-9dbc-a4cee4c4ff30",
"maintenance_window": {
"day": "saturday",
"description": [
"Update TimescaleDB to version 1.2.1",
"Upgrade to PostgreSQL 11.2 and 10.7 bugfix releases"
],
"hour": "08:45:12",
"pending": true
},
"name": "backend",
"num_nodes": 2,
"private_connection": {
"database": "",
"host": "private-backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@private-backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"private_network_uuid": "d455e75d-4858-4eec-8c95-da2f0a5f93a7",
"region": "nyc3",
"semantic_version": "14.5",
"size": "db-s-2vcpu-4gb",
"standby_connection": {
"database": "",
"host": "replica-backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@replica-backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"standby_private_connection": {
"database": "",
"host": "private-replica-backend-do-user-19081923-0.db.ondigitalocean.com",
"password": "wv78n3zpz42xezdk",
"port": 25060,
"ssl": true,
"uri": "postgres://doadmin:wv78n3zpz42xezdk@private-replica-backend-do-user-19081923-0.db.ondigitalocean.com:25060/defaultdb?sslmode=require",
"user": "doadmin"
},
"status": "creating",
"storage_size_mib": 61440,
"tags": [
"production"
],
"users": [
{
"name": "doadmin",
"password": "wv78n3zpz42xezdk",
"role": "primary"
}
],
"version": "14",
"version_end_of_availability": "2023-05-09T00:00:00Z",
"version_end_of_life": "2023-11-09T00:00:00Z"
}
}{
"id": "unauthorized",
"message": "Unable to authenticate you."
}{
"id": "not_found",
"message": "The resource you requested could not be found."
}{
"id": "too_many_requests",
"message": "API rate limit exceeded."
}{
"id": "server_error",
"message": "Unexpected server-side error"
}{
"id": "example_error",
"message": "some error message"
}GET Retrieve Database Clusters' Metrics Endpoint Credentials
/v2/databases/metrics/credentials
Authorizations:
bearer_auth
(2 scopes)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To show the credentials for all database clusters' metrics endpoints, send a GET request to /v2/databases/metrics/credentials. The result will be a JSON object with a credentials key.
Request: /v2/databases/metrics/credentials
curl -X GET \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
"https://api.digitalocean.com/v2/databases/metrics/credentials"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
creds, _, _ := client.Databases.GetMetricsCredentials(ctx)
}Responses
200
A JSON object with a key of credentials.
credentials.ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
credentials
optional
Show child properties
credentials
optional
Show child properties
basic_auth_password
optional
passwordbasic authentication password for metrics HTTP endpoint
basic_auth_username
optional
usernamebasic authentication username for metrics HTTP endpoint
401
Authentication failed due to invalid credentials.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
404
The resource was not found.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
429
The API rate limit has been exceeded.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
500
There was a server error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
default
There was an unexpected error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
Response
{
"credentials": {
"basic_auth_password": "password",
"basic_auth_username": "username"
}
}{
"id": "unauthorized",
"message": "Unable to authenticate you."
}{
"id": "not_found",
"message": "The resource you requested could not be found."
}{
"id": "too_many_requests",
"message": "API rate limit exceeded."
}{
"id": "server_error",
"message": "Unexpected server-side error"
}{
"id": "example_error",
"message": "some error message"
}PUT Update Database Clusters' Metrics Endpoint Credentials
/v2/databases/metrics/credentials
Authorizations:
bearer_auth
(1 scope)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To update the credentials for all database clusters' metrics endpoints, send a PUT request to /v2/databases/metrics/credentials. A successful request will receive a 204 No Content status code with no body in response.
Request Body: application/json
credentials
optional
Show child properties
basic_auth_password
optional
passwordbasic authentication password for metrics HTTP endpoint
basic_auth_username
optional
usernamebasic authentication username for metrics HTTP endpoint
Request: /v2/databases/metrics/credentials
{
"credentials": {
"basic_auth_password": "new_password",
"basic_auth_username": "new_username"
}
}curl -X PUT \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
-d '{"credentials": {"basic_auth_username": "new_username", "basic_auth_password": "new_password"}}'\
"https://api.digitalocean.com/v2/databases/metrics/credentials"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
_, _ = client.Databases.UpdateMetricsCredentials(ctx, &godo.DatabaseUpdateMetricsCredentialsRequest{
Credentials: &godo.DatabaseMetricsCredentials{
BasicAuthUsername: "a_new_username",
BasicAuthPassword: "a_new_password",
},
})
}Responses
204
The action was successful and the response body is empty.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
401
Authentication failed due to invalid credentials.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
429
The API rate limit has been exceeded.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
500
There was a server error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
default
There was an unexpected error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
Response
{
"id": "unauthorized",
"message": "Unable to authenticate you."
}{
"id": "too_many_requests",
"message": "API rate limit exceeded."
}{
"id": "server_error",
"message": "Unexpected server-side error"
}{
"id": "example_error",
"message": "some error message"
}GET List Database Options
/v2/databases/options
Authorizations:
bearer_auth
(1 scope)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To list all of the options available for the offered database engines, send a GET request to /v2/databases/options.
The result will be a JSON object with an options key.
Request: /v2/databases/options
curl -X GET \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
"https://api.digitalocean.com/v2/databases/options"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
options, _, err := client.Databases.ListOptions(ctx)
}import os
from pydo import Client
client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))
get_resp = client.databases.list_options()Responses
200
A JSON string with a key of options.
options.ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
options
optional
Show child properties
kafka
optional
mongodb
optional
mysql
optional
opensearch
optional
pg
optional
redis
optional
valkey
optional
version_availability
optional
Show child properties
kafka
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
mongodb
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
mysql
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
opensearch
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
pg
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
redis
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
valkey
optional
An array of objects, each indicating the version end-of-life, end-of-availability for various database engines
Show child properties
end_of_availability
optional Nullable
2023-05-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.
end_of_life
optional Nullable
2023-11-09T00:00:00ZA timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.
version
optional
8The engine version.
401
Authentication failed due to invalid credentials.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
404
The resource was not found.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
429
The API rate limit has been exceeded.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
500
There was a server error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
default
There was an unexpected error.
ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
id
required
not_foundA short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."
message
required
The resource you were accessing could not be found.A message providing additional information about the error, including details to help resolve it when possible.
request_id
optional
4d9d8375-3c56-4925-a3e7-eb137fed17e9Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.
Response
{
"options": {
"kafka": {
"default_version": "3.8",
"layouts": [
{
"num_nodes": 3,
"sizes": [
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"db-s-2vcpu-4gb",
"db-s-2vcpu-2gb"
]
},
{
"num_nodes": 6,
"sizes": [
"gd-2vcpu-8gb",
"gd-4vcpu-16gb"
]
},
{
"num_nodes": 9,
"sizes": [
"gd-2vcpu-8gb",
"gd-4vcpu-16gb"
]
},
{
"num_nodes": 15,
"sizes": [
"gd-2vcpu-8gb",
"gd-4vcpu-16gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"3.8"
]
},
"mongodb": {
"default_version": "7.0",
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"6.0",
"7.0"
]
},
"mysql": {
"default_version": "8",
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-1gb",
"db-amd-1vcpu-1gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-amd-2vcpu-8gb",
"db-intel-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-amd-4vcpu-16gb",
"db-intel-4vcpu-16gb",
"db-intel-8vcpu-32gb",
"db-amd-8vcpu-32gb",
"db-intel-16vcpu-64gb",
"db-amd-16vcpu-64gb"
]
},
{
"num_nodes": 2,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-intel-2vcpu-8gb",
"db-amd-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-intel-4vcpu-16gb",
"db-amd-4vcpu-16gb",
"db-amd-8vcpu-32gb",
"db-intel-8vcpu-32gb",
"db-amd-16vcpu-64gb",
"db-intel-16vcpu-64gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-intel-2vcpu-8gb",
"db-amd-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-intel-4vcpu-16gb",
"db-amd-4vcpu-16gb",
"db-amd-8vcpu-32gb",
"db-intel-8vcpu-32gb",
"db-amd-16vcpu-64gb",
"db-intel-16vcpu-64gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"8"
]
},
"opensearch": {
"default_version": "2",
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"gd-2vcpu-8gb",
"m3-2vcpu-16gb",
"db-s-4vcpu-8gb",
"gd-4vcpu-16gb",
"m3-4vcpu-32gb",
"m3-8vcpu-64gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-2vcpu-4gb",
"gd-2vcpu-8gb",
"m3-2vcpu-16gb",
"db-s-4vcpu-8gb",
"gd-4vcpu-16gb",
"m3-4vcpu-32gb",
"m3-8vcpu-64gb"
]
},
{
"num_nodes": 6,
"sizes": [
"gd-2vcpu-8gb",
"m3-2vcpu-16gb",
"gd-4vcpu-16gb",
"m3-4vcpu-32gb",
"m3-8vcpu-64gb"
]
},
{
"num_nodes": 9,
"sizes": [
"gd-2vcpu-8gb",
"m3-2vcpu-16gb",
"gd-4vcpu-16gb",
"m3-4vcpu-32gb",
"m3-8vcpu-64gb"
]
},
{
"num_nodes": 15,
"sizes": [
"gd-2vcpu-8gb",
"m3-2vcpu-16gb",
"gd-4vcpu-16gb",
"m3-4vcpu-32gb",
"m3-8vcpu-64gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"1",
"2"
]
},
"pg": {
"default_version": "17",
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-1gb",
"db-amd-1vcpu-1gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-amd-2vcpu-8gb",
"db-intel-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-amd-4vcpu-16gb",
"db-intel-4vcpu-16gb",
"db-intel-8vcpu-32gb",
"db-amd-8vcpu-32gb",
"db-intel-16vcpu-64gb",
"db-amd-16vcpu-64gb"
]
},
{
"num_nodes": 2,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-intel-2vcpu-8gb",
"db-amd-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-intel-4vcpu-16gb",
"db-amd-4vcpu-16gb",
"db-amd-8vcpu-32gb",
"db-intel-8vcpu-32gb",
"db-amd-16vcpu-64gb",
"db-intel-16vcpu-64gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"gd-2vcpu-8gb",
"gd-4vcpu-16gb",
"gd-8vcpu-32gb",
"gd-16vcpu-64gb",
"gd-32vcpu-128gb",
"gd-40vcpu-160gb",
"so1_5-2vcpu-16gb",
"so1_5-4vcpu-32gb",
"so1_5-8vcpu-64gb",
"so1_5-16vcpu-128gb",
"so1_5-24vcpu-192gb",
"so1_5-32vcpu-256gb",
"db-intel-1vcpu-2gb",
"db-amd-1vcpu-2gb",
"db-amd-2vcpu-4gb",
"db-intel-2vcpu-4gb",
"db-intel-2vcpu-8gb",
"db-amd-2vcpu-8gb",
"db-intel-4vcpu-8gb",
"db-amd-4vcpu-8gb",
"db-intel-4vcpu-16gb",
"db-amd-4vcpu-16gb",
"db-amd-8vcpu-32gb",
"db-intel-8vcpu-32gb",
"db-amd-16vcpu-64gb",
"db-intel-16vcpu-64gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"13",
"14",
"15",
"16",
"17"
]
},
"redis": {
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
},
{
"num_nodes": 2,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc2",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"7"
]
},
"valkey": {
"default_version": "8",
"layouts": [
{
"num_nodes": 1,
"sizes": [
"db-s-1vcpu-1gb",
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
},
{
"num_nodes": 2,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
},
{
"num_nodes": 3,
"sizes": [
"db-s-1vcpu-2gb",
"db-s-2vcpu-4gb",
"db-s-4vcpu-8gb",
"db-s-6vcpu-16gb",
"db-s-8vcpu-32gb",
"db-s-16vcpu-64gb",
"m-2vcpu-16gb",
"m-4vcpu-32gb",
"m-8vcpu-64gb",
"m-16vcpu-128gb",
"m-24vcpu-192gb",
"m-32vcpu-256gb"
]
}
],
"regions": [
"ams3",
"blr1",
"fra1",
"lon1",
"nyc1",
"nyc3",
"sfo2",
"sfo3",
"sgp1",
"syd1",
"tor1"
],
"versions": [
"8"
]
}
},
"version_availability": {
"kafka": [
{
"default": true,
"end_of_availability": "2025-06-03T00:00:00Z",
"end_of_life": null,
"version": "3.8"
}
],
"mongodb": [
{
"default": false,
"end_of_availability": null,
"end_of_life": "2025-07-01T07:00:00Z",
"version": "6.0"
},
{
"default": true,
"end_of_availability": null,
"end_of_life": "2026-08-01T07:00:00Z",
"version": "7.0"
}
],
"mysql": [
{
"default": true,
"end_of_availability": null,
"end_of_life": null,
"version": "8"
}
],
"opensearch": [
{
"default": false,
"end_of_availability": null,
"end_of_life": null,
"version": "1"
},
{
"default": true,
"end_of_availability": null,
"end_of_life": null,
"version": "2"
}
],
"pg": [
{
"default": false,
"end_of_availability": "2025-05-13T00:00:00Z",
"end_of_life": "2025-11-13T00:00:00Z",
"version": "13"
},
{
"default": false,
"end_of_availability": "2026-05-12T00:00:00Z",
"end_of_life": "2026-11-12T00:00:00Z",
"version": "14"
},
{
"default": false,
"end_of_availability": "2027-05-12T00:00:00Z",
"end_of_life": "2027-11-11T00:00:00Z",
"version": "15"
},
{
"default": false,
"end_of_availability": "2028-05-09T00:00:00Z",
"end_of_life": "2028-11-09T00:00:00Z",
"version": "16"
},
{
"default": true,
"end_of_availability": "2029-05-08T00:00:00Z",
"end_of_life": "2029-11-08T00:00:00Z",
"version": "17"
}
],
"redis": [
{
"default": true,
"end_of_availability": "2025-04-30T00:00:00Z",
"end_of_life": "2025-06-30T00:00:00Z",
"version": "7"
}
],
"valkey": [
{
"default": true,
"end_of_availability": null,
"end_of_life": null,
"version": "8"
}
]
}
}{
"id": "unauthorized",
"message": "Unable to authenticate you."
}{
"id": "not_found",
"message": "The resource you requested could not be found."
}{
"id": "too_many_requests",
"message": "API rate limit exceeded."
}{
"id": "server_error",
"message": "Unexpected server-side error"
}{
"id": "example_error",
"message": "some error message"
}GET Retrieve an Existing Database Cluster
/v2/databases/{database_cluster_uuid}
Authorizations:
bearer_auth
(1 scope)
OAuth Authentication
In order to interact with the DigitalOcean API, you or your application must authenticate.
The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.
You can generate an OAuth token by visiting the Apps & API section of the DigitalOcean control panel for your account.
An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.
Because of this, it is absolutely essential that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.
DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.
dop_v1_for personal access tokens generated in the control paneldoo_v1_for tokens generated by applications using the OAuth flowdor_v1_for OAuth refresh tokens
Scopes
Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.
Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).
| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | <resource>:read |
| POST | Create | <resource>:create |
| PUT/PATCH | Update | <resource>:update |
| DELETE | Delete | <resource>:delete |
For example, creating a new Droplet by making a POST request to the
/v2/droplets endpoint requires the droplet:create scope while
listing Droplets by making a GET request to the /v2/droplets
endpoint requires the droplet:read scope.
Each endpoint below specifies which scope is required to access it when using custom scopes.
How to Authenticate with OAuth
In order to make an authenticated request, include a bearer-type
Authorization header containing your OAuth token. All requests must be
made over HTTPS.
Authenticate with a Bearer Authorization Header
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
To show information about an existing database cluster, send a GET request to /v2/databases/$DATABASE_ID.
The response will be a JSON object with a database key. This will be set to an object containing the standard database cluster attributes.
The embedded connection and private_connection objects will contain the information needed to access the database cluster. For multi-node clusters, the standby_connection and standby_private_connection objects contain the information needed to connect to the cluster's standby node(s).
The embedded maintenance_window object will contain information about any scheduled maintenance for the database cluster.
Path Parameters
database_cluster_uuid
required
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique identifier for a database cluster.
Request: /v2/databases/{database_cluster_uuid}
curl -X GET \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
"https://api.digitalocean.com/v2/databases/9cc10173-e9ea-4176-9dbc-a4cee4c4ff30"import (
"context"
"os"
"github.com/digitalocean/godo"
)
func main() {
token := os.Getenv("DIGITALOCEAN_TOKEN")
client := godo.NewFromToken(token)
ctx := context.TODO()
cluster, _, err := client.Databases.Get(ctx, "9cc10173-e9ea-4176-9dbc-a4cee4c4ff30")
}import os
from pydo import Client
client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))
get_resp = client.databases.get_cluster(database_cluster_uuid="a7a89a")Responses
200
A JSON object with a key of database.
database.ratelimit-limit
The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.
ratelimit-remaining
The number of requests in your hourly quota that remain before you hit your request limit. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
ratelimit-reset
The time when the oldest request will expire. The value is given in Unix epoch time. See https://docs.digitalocean.com/reference/api/reference/#rate-limit for information about how requests expire.
application/json
database
required
Show child properties
connection
optional
created_at
optional read-only
2019-01-11T18:37:36ZA time value given in ISO8601 combined date and time format that represents when the database cluster was created.
db_names
optional read-only Nullable
["doadmin"]An array of strings containing the names of databases created in the database cluster.
do_settings
optional
engine
required
mysqlA slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, and "valkey" for Valkey.
id
optional read-only
9cc10173-e9ea-4176-9dbc-a4cee4c4ff30A unique ID that can be used to identify and reference a database cluster.
maintenance_window
optional
metrics_endpoints
optional read-only
Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).
Show child properties
host
optional read-only
backend-do-user-19081923-0.db.ondigitalocean.comA FQDN pointing to the database cluster's node(s).
port
optional read-only
9273The port on which a service is listening.
name
required
backendA unique, human-readable name referring to a database cluster.
num_nodes
required
2The number of nodes in the database cluster.
private_connection
optional
private_network_uuid
optional
d455e75d-4858-4eec-8c95-da2f0a5f93a7A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.
Requires vpc:read scope.
project_id
optional
[...]
